package flash.ui;

/**
 * The Keyboard class is used to build an interface that can be controlled by a user with a standard keyboard.
 * You can use the methods and properties of the Keyboard class without using a constructor. The properties of
 * the Keyboard class are constants representing the keys that are most commonly used to control games.
 * 
 * @author Thomas Weston
 */
public class Keyboard 
{
	/**
	 * Constant associated with the key code value for the A key (65).
	 */
	public static final int A = 65;
	
	/**
	 * Constant associated with the key code value for the B key (66).
	 */
	public static final int B = 66;
	
	/**
	 * Constant associated with the key code value for the button for returning to the previous page in the application.
	 */
	public static final int BACK = 0x01000016;
	
	/**
	 * Constant associated with the key code value for the ` key (192).
	 */
	public static final int BACKQUOTE = 192;
	
	/**
	 * Constant associated with the key code value for the \ key (220).
	 */
	public static final int BACKSLASH = 220;
	
	/**
	 * Constant associated with the key code value for the Backspace key (8).
	 */
	public static final int BACKSPACE = 8;
	
	/**
	 * Constant associated with the key code value for the C key (67).
	 */
	public static final int C = 67;
	
	/**
	 * Constant associated with the key code value for the Caps Lock key (20).
	 */
	public static final int CAPS_LOCK = 20;
	
	/**
	 * Constant associated with the key code value for the , key (188).
	 */
	public static final int COMMA = 188;
	
	/**
	 * Constant associated with the key code value for the Control key (17).
	 */
	public static final int CONTROL = 17;
	
	/**
	 * Constant associated with the key code value for the D key (68).
	 */
	public static final int D = 68;
	
	/**
	 * Constant associated with the key code value for the Delete key (46).
	 */
	public static final int DELETE = 46;
	
	/**
	 * Constant associated with the key code value for the Down Arrow key (40).
	 */
	public static final int DOWN = 40;
	
	/**
	 * Constant associated with the key code value for the E key (69).
	 */
	public static final int E = 69;
	
	/**
	 * Constant associated with the key code value for the End key (35).
	 */
	public static final int END = 35;
	
	/**
	 * Constant associated with the key code value for the Enter key (13).
	 */
	public static final int ENTER = 13;
	
	/**
	 * Constant associated with the key code value for the = key (187).
	 */
	public static final int EQUAL = 187;
	
	/**
	 * Constant associated with the key code value for the Escape key (27).
	 */
	public static final int ESCAPE = 27;
	
	/**
	 * Constant associated with the key code value for the F key (70).
	 */
	public static final int F = 70;
	
	/**
	 * Constant associated with the key code value for the F1 key (112).
	 */
	public static final int F1 = 112;
	
	/**
	 * Constant associated with the key code value for the F10 key (121).
	 */
	public static final int F10 = 121;
	
	/**
	 * Constant associated with the key code value for the F11 key (122).
	 */
	public static final int F11 = 122;
	
	/**
	 * Constant associated with the key code value for the F12 key (123).
	 */
	public static final int F12 = 123;
	
	/**
	 * Constant associated with the key code value for the F2 key (113).
	 */
	public static final int F2 = 113;
	
	/**
	 * Constant associated with the key code value for the F3 key (114).
	 */
	public static final int F3 = 114;
	
	/**
	 * Constant associated with the key code value for the F4 key (115).
	 */
	public static final int F4 = 115;
	
	/**
	 * Constant associated with the key code value for the F5 key (116).
	 */
	public static final int F5 = 116;
	
	/**
	 * Constant associated with the key code value for the F6 key (117).
	 */
	public static final int F6 = 117;
	
	/**
	 * Constant associated with the key code value for the F7 key (118).
	 */
	public static final int F7 = 118;
	
	/**
	 * Constant associated with the key code value for the F8 key (119).
	 */
	public static final int F8 = 119;
	
	/**
	 * Constant associated with the key code value for the F9 key (120).
	 */
	public static final int F9 = 120;
	
	/**
	 * Constant associated with the key code value for the G key (71).
	 */
	public static final int G = 71;
	
	/**
	 * Constant associated with the key code value for the H key (72).
	 */
	public static final int H = 72;
	
	/**
	 * Constant associated with the key code value for the Home key (36).
	 */
	public static final int HOME = 36;
	
	/**
	 * Constant associated with the key code value for the I key (73).
	 */
	public static final int I = 73;
	
	/**
	 * Constant associated with the key code value for the Insert key (45).
	 */
	public static final int INSERT = 45;
	
	/**
	 * Constant associated with the key code value for the J key (74).
	 */
	public static final int J = 74;
	
	/**
	 * Constant associated with the key code value for the K key (75).
	 */
	public static final int K = 75;
	
	/**
	 * Constant associated with the key code value for the L key (76).
	 */
	public static final int L = 76;
	
	/**
	 * Constant associated with the key code value for the Left Arrow key (37).
	 */
	public static final int LEFT = 37;
	
	/**
	 * Constant associated with the key code value for the [ key (219).
	 */
	public static final int LEFTBRACKET = 219;
	
	/**
	 * Constant associated with the key code value for the M key (77).
	 */
	public static final int M = 77;
	
	/**
	 * Constant associated with the key code value for the button for engaging the menu.
	 */
	public static final int MENU = 0x01000012;
	
	/**
	 * Constant associated with the key code value for the - key (189).
	 */
	public static final int MINUS = 189;
	
	/**
	 * Constant associated with the key code value for the N key (78).
	 */
	public static final int N = 78;
	
	/**
	 * Constant associated with the key code value for the 0 key (48).
	 */
	public static final int NUMBER_0 = 48;
	
	/**
	 * Constant associated with the key code value for the 1 key (49).
	 */
	public static final int NUMBER_1 = 49;
	
	/**
	 * Constant associated with the key code value for the 2 key (50).
	 */
	public static final int NUMBER_2 = 50;
	
	/**
	 * Constant associated with the key code value for the 3 key (51).
	 */
	public static final int NUMBER_3 = 51;
	
	/**
	 * Constant associated with the key code value for the 4 key (52).
	 */
	public static final int NUMBER_4 = 52;
	
	/**
	 * Constant associated with the key code value for the 5 key (53).
	 */
	public static final int NUMBER_5 = 53;
	
	/**
	 * Constant associated with the key code value for the 6 key (54).
	 */
	public static final int NUMBER_6 = 54;
	
	/**
	 * Constant associated with the key code value for the 7 key (55).
	 */
	public static final int NUMBER_7 = 55;
	
	/**
	 * Constant associated with the key code value for the 8 key (56).
	 */
	public static final int NUMBER_8 = 56;
	
	/**
	 * Constant associated with the key code value for the 9 key (57).
	 */
	public static final int NUMBER_9 = 57;
	
	/**
	 * Constant associated with the key code value for the number 0 key on the number pad (96).
	 */
	public static final int NUMPAD_0 = 96;
	
	/**
	 * Constant associated with the key code value for the number 1 key on the number pad (97).
	 */
	public static final int NUMPAD_1 = 97;
	
	/**
	 * Constant associated with the key code value for the number 2 key on the number pad (98).
	 */
	public static final int NUMPAD_2 = 98;
	
	/**
	 * Constant associated with the key code value for the number 3 key on the number pad (99).
	 */
	public static final int NUMPAD_3 = 99;
	
	/**
	 * Constant associated with the key code value for the number 4 key on the number pad (100).
	 */
	public static final int NUMPAD_4 = 100;
	
	/**
	 * Constant associated with the key code value for the number 5 key on the number pad (101).
	 */
	public static final int NUMPAD_5 = 101;
	
	/**
	 * Constant associated with the key code value for the number 6 key on the number pad (102).
	 */
	public static final int NUMPAD_6 = 102;
	
	/**
	 * Constant associated with the key code value for the number 7 key on the number pad (103).
	 */
	public static final int NUMPAD_7 = 103;
	
	/**
	 * Constant associated with the key code value for the number 8 key on the number pad (104).
	 */
	public static final int NUMPAD_8 = 104;
	
	/**
	 * Constant associated with the key code value for the number 9 key on the number pad (105).
	 */
	public static final int NUMPAD_9 = 105;
	
	/**
	 * Constant associated with the key code value for the addition key on the number pad (107).
	 */
	public static final int NUMPAD_ADD = 107;
	
	/**
	 * Constant associated with the key code value for the decimal key on the number pad (110).
	 */
	public static final int NUMPAD_DECIMAL = 110;
	
	/**
	 * Constant associated with the key code value for the division key on the number pad (111).
	 */
	public static final int NUMPAD_DIVIDE = 111;
	
	/**
	 * Constant associated with the key code value for the Enter key on the number pad (108).
	 */
	public static final int NUMPAD_ENTER = 108;
	
	/**
	 * Constant associated with the key code value for the multiplication key on the number pad (106).
	 */
	public static final int NUMPAD_MULTIPLY = 106;
	
	/**
	 * Constant associated with the key code value for the subtraction key on the number pad (109).
	 */
	public static final int NUMPAD_SUBTRACT = 109;
	
	/**
	 * Constant associated with the key code value for the O key (79).
	 */
	public static final int O = 79;
	
	/**
	 * Constant associated with the key code value for the P key (80).
	 */
	public static final int P = 80;
	
	/**
	 * Constant associated with the key code value for the Page Down key (34).
	 */
	public static final int PAGE_DOWN = 34;
	
	/**
	 * Constant associated with the key code value for the Page Up key (33).
	 */
	public static final int PAGE_UP = 33;
	
	/**
	 * Constant associated with the key code value for the . key (190).
	 */
	public static final int PERIOD = 190;
	
	/**
	 * Constant associated with the key code value for the Q key (81).
	 */
	public static final int Q = 81;
	
	/**
	 * Constant associated with the key code value for the ' key (222).
	 */
	public static final int QUOTE = 222;
	
	/**
	 * Constant associated with the key code value for the R key (82).
	 */
	public static final int R = 82;
	
	/**
	 * Constant associated with the key code value for the Right Arrow key (39).
	 */
	public static final int RIGHT = 39;
	
	/**
	 * Constant associated with the key code value for the ] key (221).
	 */
	public static final int RIGHTBRACKET = 221;
	
	/**
	 * Constant associated with the key code value for the S key (83).
	 */
	public static final int S = 83;
	
	/**
	 * Constant associated with the key code value for the button for the search button.
	 */
	public static final int SEARCH = 0x0100001F;
	
	/**
	 * Constant associated with the key code value for the ; key (186).
	 */
	public static final int SEMICOLON = 186;
	
	/**
	 * Constant associated with the key code value for the Shift key (16).
	 */
	public static final int SHIFT = 16;
	
	/**
	 * Constant associated with the key code value for the / key (191).
	 */
	public static final int SLASH = 191;
	
	/**
	 * Constant associated with the key code value for the Spacebar (32).
	 */
	public static final int SPACE = 32;
	
	/**
	 * Constant associated with the key code value for the T key (84).
	 */
	public static final int T = 84;
	
	/**
	 * Constant associated with the key code value for the Tab key (9).
	 */
	public static final int TAB = 9;
	
	/**
	 * Constant associated with the key code value for the U key (85).
	 */
	public static final int U = 85;
	
	/**
	 * Constant associated with the key code value for the Up Arrow key (38).
	 */
	public static final int UP = 38;
	
	/**
	 * Constant associated with the key code value for the V key (86).
	 */
	public static final int V = 86;
	
	/**
	 * Constant associated with the key code value for the W key (87).
	 */
	public static final int W = 87;
	
	/**
	 * Constant associated with the key code value for the X key (88).
	 */
	public static final int X = 88;
	
	/**
	 * Constant associated with the key code value for the Y key (89).
	 */
	public static final int Y = 89;
	
	/**
	 * Constant associated with the key code value for the Z key (90).
	 */
	public static final int Z = 90;
}
